﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace TechED_Demo.Utility.UI
{
    /// <summary>
    /// 显示当前排序状态的图片
    /// </summary>
    public class SortOrderImage : Image
    {
        //<img align="absMiddle" hspace="3" src="<%=ResolveClientUrl("~/images/sort_down.gif") %>" width="9" height="10" />
        protected override void CreateChildControls()
        {
            this.Attributes.Add("align", "absMiddle");
            this.Attributes.Add("hspace", "3");
            this.Width = 9;
            this.Height = 10;
            if (this.Display)
            {
                if (this.SortOrder == SortOrderType.DESC)
                {
                    this.ImageUrl = ResolveUrl("~/images/sort/sort_down.gif");
                }
                else
                {
                    this.ImageUrl = ResolveUrl("~/images/sort/sort_up.gif");
                }
            }
            else
            {
                this.ImageUrl = ResolveUrl("~/images/sort/trans_pixel.gif");
            }
        }
      
        public SortOrderType SortOrder {
            get
            {
                object orderType = ViewState["SortOrder"];
                if (orderType != null)
                {
                    return (SortOrderType)orderType;
                }
                return SortOrderType.ASC;
            }
            set
            {
                ViewState["SortOrder"] = value;
            }
        }

        public bool Display
        {
            get
            {
                object display = ViewState["Display"];
                if (display != null)
                {
                    return (bool)display;
                }
                return false;
            }
            set
            {
                ViewState["Display"] = value;
            }
        }
    }
}
