﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using TechED_Demo.Utility;
using TechED_Demo.Utility.UI;

using TechED_Demo.Web.Data;

namespace TechED_Demo.Web.Controls
{
    public partial class TestList : System.Web.UI.UserControl
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                SortLinkButton.DisplaySortImage(this, SortSaver1.CurrentSortField, string.Empty, SortSaver1.SortOrder);
                ListBind();
            }
        }

        public void SortLinkButton_OnClick(object sender, EventArgs e)
        {
            var slb = (SortLinkButton)sender;
            SortLinkButton.ChangeSortOrder(slb);
            SortSaver1.CurrentSortIndex = SortSaver1.SortFieldList.FindIndex(c => c == slb.SortField);
            SortSaver1.SortOrder = slb.SortOrder;
            SortLinkButton.DisplaySortImage(this, SortSaver1.CurrentSortField, string.Empty, SortSaver1.SortOrder);
            ListBind();
        }

        private void ListBind()
        {
            TestDBEntities tDb = new TestDBEntities();
            var list = tDb.News.OrderBy(string.Format("it.{0} {1}", SortSaver1.CurrentSortField, SortSaver1.SortOrder)).Execute(System.Data.Objects.MergeOption.AppendOnly);
            rptList.DataSource = list;
            rptList.DataBind();
        }
    }
}