﻿function dataToTxt() {
    return clipboardData.getData('text');
}

function txtToArray() {
    var _arrayA = [];
    dataToTxt().split(/\r?\n/).forEach(function(el) {
        if (el != null && el != "")
            _arrayA.push(el.split('\t'));
    }
    );
    //将匹配项文字都转化为小写，避免大小写区分引起的索引麻烦
    _arrayB = [];
    _arrayA[0].forEach(function(el) {
        _arrayB.push(el.toLowerCase());
    }
    );
    _arrayA[0] = _arrayB;
    return _arrayA;
}

function getDataFormat() {
    var thead = $("datatable").getElementsByTagName("thead")[0];
    var tdDataHead = [];
    for (var i = 1; td = thead.rows[0].cells[i]; i++) {
        //将匹配项文字都转化为小写，避免大小写区分引起的索引麻烦
        tdDataHead.push(getTdValue(td).toLowerCase());
    }
    return tdDataHead;
}

function chooseall() {
    var tbody = $("datatable").getElementsByTagName("tbody")[0];
    if (tbody.childNodes.length <= 1)
        return;

    if (window.event.srcElement.tagName == 'A') {
        var cindex = window.event.srcElement.parentElement.cellIndex;
        var v = getTdValue(tbody.firstChild.firstChild.cells[cindex]);
        for (var i = 1; i < tbody.childNodes.length; i++) {
            var row = tbody.childNodes.item(i).firstChild
            setTdValue(row.cells[cindex], v);
        }
    }
}

function setTdValue(td, value) {
    if (value == undefined && value == null)
        return;
    var obj = td.getElementsByTagName('input');
    if (obj.length == 1) {
        if (obj[0].type == 'checkbox') {
            if (value == true || value == false) {
                obj[0].checked = value;
            }
        }
        else {
            obj[0].value = value;
        }
    }
}

function getTdValue(td) {
    var obj = td.getElementsByTagName('input')
    if (obj.length == 1) {
        if (obj[0].type == 'checkbox') {
            return obj[0].checked;
        }
        else {
            return obj[0].value;
        }
    }
}

function DelAllTr() {
    var tbody = $("datatable").getElementsByTagName("tbody")[0];
    while(tbody.childNodes.length>0)
    {
        tbody.removeChild(tbody.childNodes.item(0));
    }
    checkAutoPostButtonStatus();
}

function DelSelectedTr() {
    var tbody = $("datatable").getElementsByTagName("tbody")[0];
    var trs = [];
    for (var i = 0; i < tbody.childNodes.length; i++) {
        if (getTdValue(tbody.childNodes.item(i).firstChild.cells[0])) {
            trs.push(tbody.childNodes.item(i))
        }    
    }
    trs.forEach(function(el) {
        tbody.removeChild(el);
    }
    );
    checkAutoPostButtonStatus();
}

function documentOnPaste() {
    var tbody = $("datatable").getElementsByTagName("tbody")[0];
    var oldtr = $("datatableFormat").firstChild;
    var tdDataHead = getDataFormat();

    var data = txtToArray();
    var tr = null;
    for (i = 0; i < data.length - 1; i++) {
        var tr = oldtr.cloneNode(true);
        var dataCellIndex;

        for (var j = 1; j <= tdDataHead.length; j++) {
            dataCellIndex = data[0].indexOf(tdDataHead[j - 1]);
            if (dataCellIndex > -1) {
                setTdValue(tr.firstChild.childNodes.item(j), data[i + 1][dataCellIndex]);
            }
        }
        tbody.appendChild(tr);
    }

}

function checkAutoPostButtonStatus() {
    var tbody = $("datatable").getElementsByTagName("tbody")[0];
    var btnsubmit = $("btnSubmit");
    if (tbody.childNodes.length > 0) {
        btnsubmit.disabled = false;
    }
    else {
        btnsubmit.disabled = true;
    }
}

function findRow(e) {
    if (e.tagName == "TR") {
        return e;
    }
    else if (e.tagName == "BODY") {
        return null;
    } else {
        return findRow(e.parentElement);
    }
}

document.body.onkeyup = function() {
    if (event.keyCode == 86 && event.ctrlKey) {
        documentOnPaste();
    }
}

document.onkeydown = function() {
    var t = findRow(window.event.srcElement);
    var tbody = $("datatable").getElementsByTagName("tbody")[0];
    if (event.keyCode == 38)//上
    {
        if (event.srcElement.tagName != 'INPUT')
            return;
        if (t.rowIndex == 2)
            return;
        var t1 = event.srcElement.parentElement.cellIndex;

        tbody.childNodes.item(t.rowIndex - 3).firstChild.cells[t1].getElementsByTagName('input')[0].focus();
    }
    if (event.keyCode == 40)//下
    {
        if (event.srcElement.tagName != 'INPUT')
            return;
        if (t.rowIndex == tbody.childNodes.length + 1)
            return;
        
        var t1 = event.srcElement.parentElement.cellIndex

        tbody.childNodes.item(t.rowIndex - 1).firstChild.cells[t1].getElementsByTagName('input')[0].focus();
    }
}